diff --git a/src/backend/access/bitmap/bitmap.c b/src/backend/access/bitmap/bitmap.c
index 9e1c2357d6d..1bcb048cca3 100644
--- a/src/backend/access/bitmap/bitmap.c
+++ b/src/backend/access/bitmap/bitmap.c
@@ -247,11 +247,6 @@ bmgetbitmap(PG_FUNCTION_ARGS)
 			bmvec->bm_lovBuffer = InvalidBuffer;
 		}
 	}
-	else
-	{
-		/* Return an empty bitmap */
-		bm = (Node *) tbm_create(10 * 1024L);
-	}
 
 	PG_RETURN_POINTER(bm);
 }
diff --git a/src/backend/executor/nodeBitmapIndexscan.c b/src/backend/executor/nodeBitmapIndexscan.c
index 5081d86da4d..ddfe546c016 100644
--- a/src/backend/executor/nodeBitmapIndexscan.c
+++ b/src/backend/executor/nodeBitmapIndexscan.c
@@ -58,6 +58,7 @@ MultiExecBitmapIndexScan(BitmapIndexScanState *node)
 	Node	   *bitmap = NULL;
 	IndexScanDesc scandesc;
 	bool		doscan;
+	bool        found = false;
 
 	/* Make sure we are not leaking a previous bitmap */
 	Assert(NULL == node->biss_result);
@@ -91,6 +92,16 @@ MultiExecBitmapIndexScan(BitmapIndexScanState *node)
 	{
 		bitmap = index_getbitmap(scandesc, node->biss_result);
 
+		/*
+		 * For the search list, we might encounter 2 cases on segments:
+		 * 1. none of the element can get bitmap
+		 * 2. at least one of the element can get bitmap
+		 * So we use a flag found to mark each case.
+		 * If we cannot get any bitmap, we should return an empty bitmap.
+		 */
+		if (bitmap)
+			found = true;
+
 		if ((NULL != bitmap) &&
 			!(IsA(bitmap, TIDBitmap) || IsA(bitmap, StreamBitmap)))
 		{
@@ -122,6 +133,13 @@ MultiExecBitmapIndexScan(BitmapIndexScanState *node)
 	if (node->ss.ps.instrument)
 		InstrStopNode(node->ss.ps.instrument, 1 /* nTuples */);
 
+	/*
+	 * If we cannot get any bitmap in the above while loop,
+	 * we should return an empty bitmap.
+	 */
+	if (!found)
+		bitmap = (Node *) tbm_create(10 * 1024L);
+
 	return (Node *) bitmap;
 }
 
diff --git a/src/test/regress/expected/bitmap_index.out b/src/test/regress/expected/bitmap_index.out
index 2152ad633b9..c1f7fee7077 100644
--- a/src/test/regress/expected/bitmap_index.out
+++ b/src/test/regress/expected/bitmap_index.out
@@ -18,6 +18,12 @@ select count(*) from bm_test where i in(1, 2);
     20
 (1 row)
 
+select count(*) from bm_test where i in(1, 8); -- tuple with i = 1 and i = 8 is on different segments
+ count 
+-------
+    20
+(1 row)
+
 select * from bm_test where i > 10;
  i | t 
 ---+---
diff --git a/src/test/regress/expected/bitmap_index_optimizer.out b/src/test/regress/expected/bitmap_index_optimizer.out
index 1cb48b4ee2f..53f0ad96944 100644
--- a/src/test/regress/expected/bitmap_index_optimizer.out
+++ b/src/test/regress/expected/bitmap_index_optimizer.out
@@ -18,6 +18,12 @@ select count(*) from bm_test where i in(1, 2);
     20
 (1 row)
 
+select count(*) from bm_test where i in(1, 8); -- tuple with i = 1 and i = 8 is on different segments
+ count 
+-------
+    20
+(1 row)
+
 select * from bm_test where i > 10;
  i | t 
 ---+---
diff --git a/src/test/regress/sql/bitmap_index.sql b/src/test/regress/sql/bitmap_index.sql
index de3b136dc93..c44682a9924 100644
--- a/src/test/regress/sql/bitmap_index.sql
+++ b/src/test/regress/sql/bitmap_index.sql
@@ -7,6 +7,7 @@ insert into bm_test select i % 10, (i % 10)::text  from generate_series(1, 100)
 create index bm_test_idx on bm_test using bitmap (i);
 select count(*) from bm_test where i=1;
 select count(*) from bm_test where i in(1, 2);
+select count(*) from bm_test where i in(1, 8); -- tuple with i = 1 and i = 8 is on different segments
 select * from bm_test where i > 10;
 reindex index bm_test_idx;
 select count(*) from bm_test where i in(1, 2);
